
package org.dmg.pmml;

import java.util.ArrayList;
import java.util.List;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlType;
import org.jvnet.jaxb2_commons.lang.Equals;
import org.jvnet.jaxb2_commons.lang.EqualsStrategy;
import org.jvnet.jaxb2_commons.lang.HashCode;
import org.jvnet.jaxb2_commons.lang.HashCodeStrategy;
import org.jvnet.jaxb2_commons.lang.JAXBEqualsStrategy;
import org.jvnet.jaxb2_commons.lang.JAXBHashCodeStrategy;
import org.jvnet.jaxb2_commons.lang.JAXBToStringStrategy;
import org.jvnet.jaxb2_commons.lang.ToString;
import org.jvnet.jaxb2_commons.lang.ToStringStrategy;
import org.jvnet.jaxb2_commons.locator.ObjectLocator;
import org.jvnet.jaxb2_commons.locator.util.LocatorUtils;


/**
 * <p>Java class for anonymous complex type.
 * 
 * <p>The following schema fragment specifies the expected content contained within this class.
 * 
 * <pre>
 * &lt;complexType>
 *   &lt;complexContent>
 *     &lt;restriction base="{http://www.w3.org/2001/XMLSchema}anyType">
 *       &lt;sequence>
 *         &lt;element ref="{http://www.dmg.org/PMML-4_1}Extension" maxOccurs="unbounded" minOccurs="0"/>
 *         &lt;element ref="{http://www.dmg.org/PMML-4_1}CorrelationFields"/>
 *         &lt;element ref="{http://www.dmg.org/PMML-4_1}CorrelationValues"/>
 *         &lt;element ref="{http://www.dmg.org/PMML-4_1}CorrelationMethods" minOccurs="0"/>
 *       &lt;/sequence>
 *     &lt;/restriction>
 *   &lt;/complexContent>
 * &lt;/complexType>
 * </pre>
 * 
 * 
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "", propOrder = {
    "extensions",
    "correlationFields",
    "correlationValues",
    "correlationMethods"
})
@XmlRootElement(name = "Correlations")
@Schema(min = Version.PMML_4_0)
public class Correlations
    extends PMMLObject
    implements Equals, HashCode, ToString
{

    @XmlElement(name = "Extension")
    protected List<Extension> extensions;
    @XmlElement(name = "CorrelationFields", required = true)
    protected CorrelationFields correlationFields;
    @XmlElement(name = "CorrelationValues", required = true)
    protected CorrelationValues correlationValues;
    @XmlElement(name = "CorrelationMethods")
    protected CorrelationMethods correlationMethods;

    @Deprecated
    public Correlations() {
        super();
    }

    public Correlations(final CorrelationFields correlationFields, final CorrelationValues correlationValues) {
        super();
        this.correlationFields = correlationFields;
        this.correlationValues = correlationValues;
    }

    /**
     * Gets the value of the extensions property.
     * 
     * <p>
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the JAXB object.
     * This is why there is not a <CODE>set</CODE> method for the extensions property.
     * 
     * <p>
     * For example, to add a new item, do as follows:
     * <pre>
     *    getExtensions().add(newItem);
     * </pre>
     * 
     * 
     * <p>
     * Objects of the following type(s) are allowed in the list
     * {@link Extension }
     * 
     * 
     */
    public List<Extension> getExtensions() {
        if (extensions == null) {
            extensions = new ArrayList<Extension>();
        }
        return this.extensions;
    }

    /**
     * Gets the value of the correlationFields property.
     * 
     * @return
     *     possible object is
     *     {@link CorrelationFields }
     *     
     */
    public CorrelationFields getCorrelationFields() {
        return correlationFields;
    }

    /**
     * Sets the value of the correlationFields property.
     * 
     * @param value
     *     allowed object is
     *     {@link CorrelationFields }
     *     
     */
    public void setCorrelationFields(CorrelationFields value) {
        this.correlationFields = value;
    }

    /**
     * Gets the value of the correlationValues property.
     * 
     * @return
     *     possible object is
     *     {@link CorrelationValues }
     *     
     */
    public CorrelationValues getCorrelationValues() {
        return correlationValues;
    }

    /**
     * Sets the value of the correlationValues property.
     * 
     * @param value
     *     allowed object is
     *     {@link CorrelationValues }
     *     
     */
    public void setCorrelationValues(CorrelationValues value) {
        this.correlationValues = value;
    }

    /**
     * Gets the value of the correlationMethods property.
     * 
     * @return
     *     possible object is
     *     {@link CorrelationMethods }
     *     
     */
    public CorrelationMethods getCorrelationMethods() {
        return correlationMethods;
    }

    /**
     * Sets the value of the correlationMethods property.
     * 
     * @param value
     *     allowed object is
     *     {@link CorrelationMethods }
     *     
     */
    public void setCorrelationMethods(CorrelationMethods value) {
        this.correlationMethods = value;
    }

    public boolean equals(ObjectLocator thisLocator, ObjectLocator thatLocator, Object object, EqualsStrategy strategy) {
        if (!(object instanceof Correlations)) {
            return false;
        }
        if (this == object) {
            return true;
        }
        if (!super.equals(thisLocator, thatLocator, object, strategy)) {
            return false;
        }
        final Correlations that = ((Correlations) object);
        {
            List<Extension> lhsExtensions;
            lhsExtensions = (((this.extensions!= null)&&(!this.extensions.isEmpty()))?this.getExtensions():null);
            List<Extension> rhsExtensions;
            rhsExtensions = (((that.extensions!= null)&&(!that.extensions.isEmpty()))?that.getExtensions():null);
            if (!strategy.equals(LocatorUtils.property(thisLocator, "extensions", lhsExtensions), LocatorUtils.property(thatLocator, "extensions", rhsExtensions), lhsExtensions, rhsExtensions)) {
                return false;
            }
        }
        {
            CorrelationFields lhsCorrelationFields;
            lhsCorrelationFields = this.getCorrelationFields();
            CorrelationFields rhsCorrelationFields;
            rhsCorrelationFields = that.getCorrelationFields();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "correlationFields", lhsCorrelationFields), LocatorUtils.property(thatLocator, "correlationFields", rhsCorrelationFields), lhsCorrelationFields, rhsCorrelationFields)) {
                return false;
            }
        }
        {
            CorrelationValues lhsCorrelationValues;
            lhsCorrelationValues = this.getCorrelationValues();
            CorrelationValues rhsCorrelationValues;
            rhsCorrelationValues = that.getCorrelationValues();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "correlationValues", lhsCorrelationValues), LocatorUtils.property(thatLocator, "correlationValues", rhsCorrelationValues), lhsCorrelationValues, rhsCorrelationValues)) {
                return false;
            }
        }
        {
            CorrelationMethods lhsCorrelationMethods;
            lhsCorrelationMethods = this.getCorrelationMethods();
            CorrelationMethods rhsCorrelationMethods;
            rhsCorrelationMethods = that.getCorrelationMethods();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "correlationMethods", lhsCorrelationMethods), LocatorUtils.property(thatLocator, "correlationMethods", rhsCorrelationMethods), lhsCorrelationMethods, rhsCorrelationMethods)) {
                return false;
            }
        }
        return true;
    }

    public boolean equals(Object object) {
        final EqualsStrategy strategy = JAXBEqualsStrategy.INSTANCE;
        return equals(null, null, object, strategy);
    }

    public int hashCode(ObjectLocator locator, HashCodeStrategy strategy) {
        int currentHashCode = super.hashCode(locator, strategy);
        {
            List<Extension> theExtensions;
            theExtensions = (((this.extensions!= null)&&(!this.extensions.isEmpty()))?this.getExtensions():null);
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "extensions", theExtensions), currentHashCode, theExtensions);
        }
        {
            CorrelationFields theCorrelationFields;
            theCorrelationFields = this.getCorrelationFields();
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "correlationFields", theCorrelationFields), currentHashCode, theCorrelationFields);
        }
        {
            CorrelationValues theCorrelationValues;
            theCorrelationValues = this.getCorrelationValues();
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "correlationValues", theCorrelationValues), currentHashCode, theCorrelationValues);
        }
        {
            CorrelationMethods theCorrelationMethods;
            theCorrelationMethods = this.getCorrelationMethods();
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "correlationMethods", theCorrelationMethods), currentHashCode, theCorrelationMethods);
        }
        return currentHashCode;
    }

    public int hashCode() {
        final HashCodeStrategy strategy = JAXBHashCodeStrategy.INSTANCE;
        return this.hashCode(null, strategy);
    }

    public String toString() {
        final ToStringStrategy strategy = JAXBToStringStrategy.INSTANCE;
        final StringBuilder buffer = new StringBuilder();
        append(null, buffer, strategy);
        return buffer.toString();
    }

    public StringBuilder append(ObjectLocator locator, StringBuilder buffer, ToStringStrategy strategy) {
        strategy.appendStart(locator, this, buffer);
        appendFields(locator, buffer, strategy);
        strategy.appendEnd(locator, this, buffer);
        return buffer;
    }

    public StringBuilder appendFields(ObjectLocator locator, StringBuilder buffer, ToStringStrategy strategy) {
        super.appendFields(locator, buffer, strategy);
        {
            List<Extension> theExtensions;
            theExtensions = (((this.extensions!= null)&&(!this.extensions.isEmpty()))?this.getExtensions():null);
            strategy.appendField(locator, this, "extensions", buffer, theExtensions);
        }
        {
            CorrelationFields theCorrelationFields;
            theCorrelationFields = this.getCorrelationFields();
            strategy.appendField(locator, this, "correlationFields", buffer, theCorrelationFields);
        }
        {
            CorrelationValues theCorrelationValues;
            theCorrelationValues = this.getCorrelationValues();
            strategy.appendField(locator, this, "correlationValues", buffer, theCorrelationValues);
        }
        {
            CorrelationMethods theCorrelationMethods;
            theCorrelationMethods = this.getCorrelationMethods();
            strategy.appendField(locator, this, "correlationMethods", buffer, theCorrelationMethods);
        }
        return buffer;
    }

}
