
package org.dmg.pmml;

import java.util.ArrayList;
import java.util.List;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlType;
import org.jvnet.jaxb2_commons.lang.Equals;
import org.jvnet.jaxb2_commons.lang.EqualsStrategy;
import org.jvnet.jaxb2_commons.lang.HashCode;
import org.jvnet.jaxb2_commons.lang.HashCodeStrategy;
import org.jvnet.jaxb2_commons.lang.JAXBEqualsStrategy;
import org.jvnet.jaxb2_commons.lang.JAXBHashCodeStrategy;
import org.jvnet.jaxb2_commons.lang.JAXBToStringStrategy;
import org.jvnet.jaxb2_commons.lang.ToString;
import org.jvnet.jaxb2_commons.lang.ToStringStrategy;
import org.jvnet.jaxb2_commons.locator.ObjectLocator;
import org.jvnet.jaxb2_commons.locator.util.LocatorUtils;


/**
 * <p>Java class for anonymous complex type.
 * 
 * <p>The following schema fragment specifies the expected content contained within this class.
 * 
 * <pre>
 * &lt;complexType>
 *   &lt;complexContent>
 *     &lt;restriction base="{http://www.w3.org/2001/XMLSchema}anyType">
 *       &lt;sequence>
 *         &lt;element ref="{http://www.dmg.org/PMML-4_1}Extension" maxOccurs="unbounded" minOccurs="0"/>
 *         &lt;element ref="{http://www.dmg.org/PMML-4_1}ModelLiftGraph"/>
 *         &lt;element ref="{http://www.dmg.org/PMML-4_1}OptimumLiftGraph" minOccurs="0"/>
 *         &lt;element ref="{http://www.dmg.org/PMML-4_1}RandomLiftGraph" minOccurs="0"/>
 *       &lt;/sequence>
 *       &lt;attribute name="targetFieldValue" type="{http://www.w3.org/2001/XMLSchema}string" />
 *       &lt;attribute name="targetFieldDisplayValue" type="{http://www.w3.org/2001/XMLSchema}string" />
 *       &lt;attribute name="rankingQuality" type="{http://www.dmg.org/PMML-4_1}NUMBER" />
 *     &lt;/restriction>
 *   &lt;/complexContent>
 * &lt;/complexType>
 * </pre>
 * 
 * 
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "", propOrder = {
    "extensions",
    "modelLiftGraph",
    "optimumLiftGraph",
    "randomLiftGraph"
})
@XmlRootElement(name = "LiftData")
@Schema(min = Version.PMML_4_0)
public class LiftData
    extends PMMLObject
    implements Equals, HashCode, ToString
{

    @XmlElement(name = "Extension")
    protected List<Extension> extensions;
    @XmlElement(name = "ModelLiftGraph", required = true)
    protected ModelLiftGraph modelLiftGraph;
    @XmlElement(name = "OptimumLiftGraph")
    protected OptimumLiftGraph optimumLiftGraph;
    @XmlElement(name = "RandomLiftGraph")
    protected RandomLiftGraph randomLiftGraph;
    @XmlAttribute(name = "targetFieldValue")
    protected String targetFieldValue;
    @XmlAttribute(name = "targetFieldDisplayValue")
    protected String targetFieldDisplayValue;
    @XmlAttribute(name = "rankingQuality")
    protected Double rankingQuality;

    @Deprecated
    public LiftData() {
        super();
    }

    public LiftData(final ModelLiftGraph modelLiftGraph) {
        super();
        this.modelLiftGraph = modelLiftGraph;
    }

    /**
     * Gets the value of the extensions property.
     * 
     * <p>
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the JAXB object.
     * This is why there is not a <CODE>set</CODE> method for the extensions property.
     * 
     * <p>
     * For example, to add a new item, do as follows:
     * <pre>
     *    getExtensions().add(newItem);
     * </pre>
     * 
     * 
     * <p>
     * Objects of the following type(s) are allowed in the list
     * {@link Extension }
     * 
     * 
     */
    public List<Extension> getExtensions() {
        if (extensions == null) {
            extensions = new ArrayList<Extension>();
        }
        return this.extensions;
    }

    /**
     * Gets the value of the modelLiftGraph property.
     * 
     * @return
     *     possible object is
     *     {@link ModelLiftGraph }
     *     
     */
    public ModelLiftGraph getModelLiftGraph() {
        return modelLiftGraph;
    }

    /**
     * Sets the value of the modelLiftGraph property.
     * 
     * @param value
     *     allowed object is
     *     {@link ModelLiftGraph }
     *     
     */
    public void setModelLiftGraph(ModelLiftGraph value) {
        this.modelLiftGraph = value;
    }

    /**
     * Gets the value of the optimumLiftGraph property.
     * 
     * @return
     *     possible object is
     *     {@link OptimumLiftGraph }
     *     
     */
    public OptimumLiftGraph getOptimumLiftGraph() {
        return optimumLiftGraph;
    }

    /**
     * Sets the value of the optimumLiftGraph property.
     * 
     * @param value
     *     allowed object is
     *     {@link OptimumLiftGraph }
     *     
     */
    public void setOptimumLiftGraph(OptimumLiftGraph value) {
        this.optimumLiftGraph = value;
    }

    /**
     * Gets the value of the randomLiftGraph property.
     * 
     * @return
     *     possible object is
     *     {@link RandomLiftGraph }
     *     
     */
    public RandomLiftGraph getRandomLiftGraph() {
        return randomLiftGraph;
    }

    /**
     * Sets the value of the randomLiftGraph property.
     * 
     * @param value
     *     allowed object is
     *     {@link RandomLiftGraph }
     *     
     */
    public void setRandomLiftGraph(RandomLiftGraph value) {
        this.randomLiftGraph = value;
    }

    /**
     * Gets the value of the targetFieldValue property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getTargetFieldValue() {
        return targetFieldValue;
    }

    /**
     * Sets the value of the targetFieldValue property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setTargetFieldValue(String value) {
        this.targetFieldValue = value;
    }

    /**
     * Gets the value of the targetFieldDisplayValue property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getTargetFieldDisplayValue() {
        return targetFieldDisplayValue;
    }

    /**
     * Sets the value of the targetFieldDisplayValue property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setTargetFieldDisplayValue(String value) {
        this.targetFieldDisplayValue = value;
    }

    /**
     * Gets the value of the rankingQuality property.
     * 
     * @return
     *     possible object is
     *     {@link Double }
     *     
     */
    public Double getRankingQuality() {
        return rankingQuality;
    }

    /**
     * Sets the value of the rankingQuality property.
     * 
     * @param value
     *     allowed object is
     *     {@link Double }
     *     
     */
    public void setRankingQuality(Double value) {
        this.rankingQuality = value;
    }

    public boolean equals(ObjectLocator thisLocator, ObjectLocator thatLocator, Object object, EqualsStrategy strategy) {
        if (!(object instanceof LiftData)) {
            return false;
        }
        if (this == object) {
            return true;
        }
        if (!super.equals(thisLocator, thatLocator, object, strategy)) {
            return false;
        }
        final LiftData that = ((LiftData) object);
        {
            List<Extension> lhsExtensions;
            lhsExtensions = (((this.extensions!= null)&&(!this.extensions.isEmpty()))?this.getExtensions():null);
            List<Extension> rhsExtensions;
            rhsExtensions = (((that.extensions!= null)&&(!that.extensions.isEmpty()))?that.getExtensions():null);
            if (!strategy.equals(LocatorUtils.property(thisLocator, "extensions", lhsExtensions), LocatorUtils.property(thatLocator, "extensions", rhsExtensions), lhsExtensions, rhsExtensions)) {
                return false;
            }
        }
        {
            ModelLiftGraph lhsModelLiftGraph;
            lhsModelLiftGraph = this.getModelLiftGraph();
            ModelLiftGraph rhsModelLiftGraph;
            rhsModelLiftGraph = that.getModelLiftGraph();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "modelLiftGraph", lhsModelLiftGraph), LocatorUtils.property(thatLocator, "modelLiftGraph", rhsModelLiftGraph), lhsModelLiftGraph, rhsModelLiftGraph)) {
                return false;
            }
        }
        {
            OptimumLiftGraph lhsOptimumLiftGraph;
            lhsOptimumLiftGraph = this.getOptimumLiftGraph();
            OptimumLiftGraph rhsOptimumLiftGraph;
            rhsOptimumLiftGraph = that.getOptimumLiftGraph();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "optimumLiftGraph", lhsOptimumLiftGraph), LocatorUtils.property(thatLocator, "optimumLiftGraph", rhsOptimumLiftGraph), lhsOptimumLiftGraph, rhsOptimumLiftGraph)) {
                return false;
            }
        }
        {
            RandomLiftGraph lhsRandomLiftGraph;
            lhsRandomLiftGraph = this.getRandomLiftGraph();
            RandomLiftGraph rhsRandomLiftGraph;
            rhsRandomLiftGraph = that.getRandomLiftGraph();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "randomLiftGraph", lhsRandomLiftGraph), LocatorUtils.property(thatLocator, "randomLiftGraph", rhsRandomLiftGraph), lhsRandomLiftGraph, rhsRandomLiftGraph)) {
                return false;
            }
        }
        {
            String lhsTargetFieldValue;
            lhsTargetFieldValue = this.getTargetFieldValue();
            String rhsTargetFieldValue;
            rhsTargetFieldValue = that.getTargetFieldValue();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "targetFieldValue", lhsTargetFieldValue), LocatorUtils.property(thatLocator, "targetFieldValue", rhsTargetFieldValue), lhsTargetFieldValue, rhsTargetFieldValue)) {
                return false;
            }
        }
        {
            String lhsTargetFieldDisplayValue;
            lhsTargetFieldDisplayValue = this.getTargetFieldDisplayValue();
            String rhsTargetFieldDisplayValue;
            rhsTargetFieldDisplayValue = that.getTargetFieldDisplayValue();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "targetFieldDisplayValue", lhsTargetFieldDisplayValue), LocatorUtils.property(thatLocator, "targetFieldDisplayValue", rhsTargetFieldDisplayValue), lhsTargetFieldDisplayValue, rhsTargetFieldDisplayValue)) {
                return false;
            }
        }
        {
            Double lhsRankingQuality;
            lhsRankingQuality = this.getRankingQuality();
            Double rhsRankingQuality;
            rhsRankingQuality = that.getRankingQuality();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "rankingQuality", lhsRankingQuality), LocatorUtils.property(thatLocator, "rankingQuality", rhsRankingQuality), lhsRankingQuality, rhsRankingQuality)) {
                return false;
            }
        }
        return true;
    }

    public boolean equals(Object object) {
        final EqualsStrategy strategy = JAXBEqualsStrategy.INSTANCE;
        return equals(null, null, object, strategy);
    }

    public int hashCode(ObjectLocator locator, HashCodeStrategy strategy) {
        int currentHashCode = super.hashCode(locator, strategy);
        {
            List<Extension> theExtensions;
            theExtensions = (((this.extensions!= null)&&(!this.extensions.isEmpty()))?this.getExtensions():null);
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "extensions", theExtensions), currentHashCode, theExtensions);
        }
        {
            ModelLiftGraph theModelLiftGraph;
            theModelLiftGraph = this.getModelLiftGraph();
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "modelLiftGraph", theModelLiftGraph), currentHashCode, theModelLiftGraph);
        }
        {
            OptimumLiftGraph theOptimumLiftGraph;
            theOptimumLiftGraph = this.getOptimumLiftGraph();
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "optimumLiftGraph", theOptimumLiftGraph), currentHashCode, theOptimumLiftGraph);
        }
        {
            RandomLiftGraph theRandomLiftGraph;
            theRandomLiftGraph = this.getRandomLiftGraph();
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "randomLiftGraph", theRandomLiftGraph), currentHashCode, theRandomLiftGraph);
        }
        {
            String theTargetFieldValue;
            theTargetFieldValue = this.getTargetFieldValue();
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "targetFieldValue", theTargetFieldValue), currentHashCode, theTargetFieldValue);
        }
        {
            String theTargetFieldDisplayValue;
            theTargetFieldDisplayValue = this.getTargetFieldDisplayValue();
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "targetFieldDisplayValue", theTargetFieldDisplayValue), currentHashCode, theTargetFieldDisplayValue);
        }
        {
            Double theRankingQuality;
            theRankingQuality = this.getRankingQuality();
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "rankingQuality", theRankingQuality), currentHashCode, theRankingQuality);
        }
        return currentHashCode;
    }

    public int hashCode() {
        final HashCodeStrategy strategy = JAXBHashCodeStrategy.INSTANCE;
        return this.hashCode(null, strategy);
    }

    public String toString() {
        final ToStringStrategy strategy = JAXBToStringStrategy.INSTANCE;
        final StringBuilder buffer = new StringBuilder();
        append(null, buffer, strategy);
        return buffer.toString();
    }

    public StringBuilder append(ObjectLocator locator, StringBuilder buffer, ToStringStrategy strategy) {
        strategy.appendStart(locator, this, buffer);
        appendFields(locator, buffer, strategy);
        strategy.appendEnd(locator, this, buffer);
        return buffer;
    }

    public StringBuilder appendFields(ObjectLocator locator, StringBuilder buffer, ToStringStrategy strategy) {
        super.appendFields(locator, buffer, strategy);
        {
            List<Extension> theExtensions;
            theExtensions = (((this.extensions!= null)&&(!this.extensions.isEmpty()))?this.getExtensions():null);
            strategy.appendField(locator, this, "extensions", buffer, theExtensions);
        }
        {
            ModelLiftGraph theModelLiftGraph;
            theModelLiftGraph = this.getModelLiftGraph();
            strategy.appendField(locator, this, "modelLiftGraph", buffer, theModelLiftGraph);
        }
        {
            OptimumLiftGraph theOptimumLiftGraph;
            theOptimumLiftGraph = this.getOptimumLiftGraph();
            strategy.appendField(locator, this, "optimumLiftGraph", buffer, theOptimumLiftGraph);
        }
        {
            RandomLiftGraph theRandomLiftGraph;
            theRandomLiftGraph = this.getRandomLiftGraph();
            strategy.appendField(locator, this, "randomLiftGraph", buffer, theRandomLiftGraph);
        }
        {
            String theTargetFieldValue;
            theTargetFieldValue = this.getTargetFieldValue();
            strategy.appendField(locator, this, "targetFieldValue", buffer, theTargetFieldValue);
        }
        {
            String theTargetFieldDisplayValue;
            theTargetFieldDisplayValue = this.getTargetFieldDisplayValue();
            strategy.appendField(locator, this, "targetFieldDisplayValue", buffer, theTargetFieldDisplayValue);
        }
        {
            Double theRankingQuality;
            theRankingQuality = this.getRankingQuality();
            strategy.appendField(locator, this, "rankingQuality", buffer, theRankingQuality);
        }
        return buffer;
    }

}
